org.cpsolver.coursett.neighbourhoods

## Class TimeChange

- java.lang.Object
- - org.cpsolver.ifs.algorithms.neighbourhoods.RandomMove<Lecture,Placement>
  - - org.cpsolver.coursett.neighbourhoods.TimeChange

- All Implemented Interfaces:
    HillClimberSelection, NeighbourSelection<Lecture,Placement>

      public class TimeChange
      extends RandomMove<Lecture,Placement>

  Try to assign a class with a new time. A class is selected randomly, a different (available) time is randomly selected for the class -- the class is assigned into the new time if there is no conflict.
  Version:
    IFS 1.3 (Iterative Forward Search)
    Copyright (C) 2014 Tomáš Müller
    muller@unitime.org
    http://muller.unitime.org
    This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
    This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
    You should have received a copy of the GNU Lesser General Public License along with this library; if not see http://www.gnu.org/licenses/.
  Author:
    Tomáš Müller

- - ### Field Summary

    - ### Fields inherited from class org.cpsolver.ifs.algorithms.neighbourhoods.RandomMove

      `iHC`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `TimeChange(DataProperties config)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `Neighbour<Lecture,Placement>` | `selectNeighbour(Solution<Lecture,Placement> solution)` select a neighbour of a given solution

    - ### Methods inherited from class org.cpsolver.ifs.algorithms.neighbourhoods.RandomMove

      `init, setHcMode`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### TimeChange

          public TimeChange(DataProperties config)

  - ### Method Detail

    - #### selectNeighbour

          public Neighbour<Lecture,Placement> selectNeighbour(Solution<Lecture,Placement> solution)

      Description copied from interface: `NeighbourSelection`
      select a neighbour of a given solution
      Specified by:
        `selectNeighbour` in interface `NeighbourSelection<Lecture,Placement>`
      Overrides:
        `selectNeighbour` in class `RandomMove<Lecture,Placement>`
      Parameters:
        `solution` - given solution
      Returns:
        a neighbour assignment